extends Node2D
class_name GridObject


var TOKEN_SIZE:Vector2

#var timer:Timer
var tween:Tween

var age:float
var bounds:Rect2
var grid_pos:Vector2 = Vector2.ONE * -10
var state



#func _ready():
#	pass # Replace with function body.


func _init():
	position = Vector2.ONE * -1
	age = OS.get_system_time_msecs()

	tween = Tween.new()
	add_child(tween)


func at_coord(v:Vector2) -> bool:
	return bounds.has_point(v)


func grid_to_pixel(v:Vector2) -> Vector2:
	return v * TOKEN_SIZE


func move_to(p:Vector2) -> void:
	if p != grid_pos:
		var d := grid_pos.distance_to(p)
		var speed := 0.1 * (d + 0)

		position = grid_to_pixel(grid_pos)
		var new_pos = grid_to_pixel(p)

		tween.interpolate_property(self, 'position',
				position, new_pos, speed,
				Tween.TRANS_CUBIC, Tween.EASE_IN_OUT)
		tween.start()

		grid_pos = p
		bounds.position = new_pos - TOKEN_SIZE / 2.0


func teleport_to(p:Vector2) -> void:
	if p != grid_pos:
		grid_pos = p
		position = grid_to_pixel(grid_pos)
		bounds.position = position - TOKEN_SIZE / 2.0


# Called every frame. 'delta' is the elapsed time since the previous frame.
#func _process(delta):
#	pass
