extends GridObject
class_name Obstacle


enum {
	TYPE_THORN,
	}

var captive:Token

var trap_type := TYPE_THORN

var obstacle_images = [
	'res://art/thorn01.png',
	]


#func _ready():
#	pass # Replace with function body.


func _init(in_type:int=0, in_pos:Vector2=Vector2.ZERO):
	trap_type = in_type
	make_sprite()
	teleport_to(in_pos)

	add_to_group('obstacles', true)


func die() -> void:
	queue_free()


func make_sprite() -> void:
	var spr := Sprite.new()
	spr.texture = load(obstacle_images[trap_type])
#	spr.scale = Vector2.ONE * 0.25
	bounds = spr.get_rect()
	bounds.size *= spr.scale
	TOKEN_SIZE = bounds.size
	bounds.position -= TOKEN_SIZE / 2.0
	add_child(spr)


func near_match(pos:Vector2) -> void:
	var dist := 0.0
	var t = OS.get_system_time_msecs()

	if trap_type == TYPE_THORN and t > age + 1000.0:
		dist = grid_pos.distance_squared_to(pos)
		if dist == 1.0:
			die()


func spring(tok:Token) -> bool:
	if trap_type == TYPE_THORN and tok != null and tok.color != tok.MAX_COLOR:
		tok.thorn()
		die()
		return true

	return false


func take_captive(tok:Token) -> void:
	captive = tok


# Called every frame. 'delta' is the elapsed time since the previous frame.
#func _process(delta):
#	pass
